aboutsummaryrefslogtreecommitdiff
path: root/gdb/make-init-c
diff options
context:
space:
mode:
authorSimon Marchi <simon.marchi@polymtl.ca>2021-05-27 13:59:01 -0400
committerSimon Marchi <simon.marchi@polymtl.ca>2021-05-27 14:00:08 -0400
commitf39632d9579d3c97f1e50a728efed3c5409747d2 (patch)
treee4dd9836cd1491d773ab60a996b4b239a2696489 /gdb/make-init-c
parent5e84b7eefba5b4299b0ca80aecc5d4e99c195c1e (diff)
downloadgdb-f39632d9579d3c97f1e50a728efed3c5409747d2.zip
gdb-f39632d9579d3c97f1e50a728efed3c5409747d2.tar.gz
gdb-f39632d9579d3c97f1e50a728efed3c5409747d2.tar.bz2
gdb: add make-init-c script
I would like to modify how the init.c file is generated (its content). But as it is, a shell script with multiple sed invocations in a Makefile target, it's not very maintainable. Replace that with a shell script that does the same, but in a more readable way. The Makefile rule uses the "-" prefix in front of the for loop, I presume to ignore any error coming from the fact that xml-builtin.c and cp-name-parser.c are not found in the srcdir (they are generated source files). I prefer not to blindly ignore errors, so filter these files out of INIT_FILES instead (we already filter out other files). There are no expected meaningful changes to the generated init.c file. Just the _initialize_all_file declaration that is moved down and "void" in parenthesis that is removed. The new regular expression is a bit tighter than the existing one, it requires the init function to be followed by exactly ` ()`. Update bpf-tdep.c accordingly. gdb/ChangeLog: * Makefile.in (INIT_FILES_FILTER_OUT): New. (INIT_FILES): Use INIT_FILES_FILTER_OUT. (stamp-init): Use make-init-c. * bpf-tdep.c (_initialize_bpf_tdep): Remove "void". * silent-rules.mk (ECHO_INIT_C): Change. * make-init-c: New file. Change-Id: I6d6b12cbccf24ab79d1219bff05df01624c684f9
Diffstat (limited to 'gdb/make-init-c')
-rwxr-xr-xgdb/make-init-c57
1 files changed, 57 insertions, 0 deletions
diff --git a/gdb/make-init-c b/gdb/make-init-c
new file mode 100755
index 0000000..1588760
--- /dev/null
+++ b/gdb/make-init-c
@@ -0,0 +1,57 @@
+#!/usr/bin/env sh
+
+# Copyright (C) 2013-2021 Free Software Foundation, Inc.
+#
+# This file is part of GDB.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+# Generate the init.c source file.
+#
+# Usage:
+#
+# ./make-init-c source-files > init.c-tmp
+#
+# Where SOURCE-FILES is the list of source files to extract init functions from.
+#
+# Formatting conventions: The name of the initialization routines must begin
+# with `_initialize_`, must start in column zero, and be followed with exactly
+# ` ()`. For example:
+#
+# void
+# _initialize_foo ()
+# {
+# ...
+# }
+#
+
+# Abort on command error.
+set -e
+
+echo "/* Do not modify this file. */"
+echo "/* It is created automatically by the Makefile. */"
+echo "#include \"defs.h\" /* For initialize_file_ftype. */"
+echo ""
+sed -n -e 's/^\(_initialize_[a-zA-Z0-9_]*\) ()$/\1/p' "$@" | while read -r name; do
+ echo "extern initialize_file_ftype $name;"
+done
+echo ""
+echo "void initialize_all_files ();"
+echo "void"
+echo "initialize_all_files ()"
+echo "{"
+sed -n -e 's/^\(_initialize_[a-zA-Z0-9_]*\) ()$/\1/p' "$@" | while read -r name; do
+ echo " $name ();"
+done
+echo "}"